/*****************************************************************************
 * HBarCode2D.h
 ***************************************************************************** 
 *
 * Project:     Halcon/C++
 * Description: Class HBarCode2D
 *
 * (c) 1996-2001 by MVTec Software GmbH
 *                  Neherstr. 1, 81675 Muenchen, Germany
 * 
 *****************************************************************************
 *
 * $Revision: 1.4 $
 * $Date: 2003/10/02 09:51:40 $
 *
 */

#ifndef H_BAR_CODE_2D_H
#define H_BAR_CODE_2D_H

class LIntExport HBarCode2D: public HRootObject {
public:
  HBarCode2D(void) {id = -1;} 
  HBarCode2D(const HTuple &CodeType, 
             const HTuple &GenParamNames, 
             const HTuple &GenParamValues);

private:
  // Internal Cleanup
  void Cleanup(void);

public:
  // Tools
  const char *ClassName(void) const {return "HBarCode2D";}

  // Cast Operator
  operator HTuple () const {return GetHandle();}

  // Access and Manipulation
  HTuple GetHandle(void) const {return id;}
  void   SetHandle(long ID) {id = ID;}

private:
  HTuple  id;
public:
  // Decode 2D bar code data.
  virtual HTuple Decode2dBarCode(const HTuple &BarCodeDimension, const HTuple &BarCodeData, HTuple *CorrSymbolData, HTuple *DecodedData, HTuple *DecodingError, HTuple *StructuredAppend) const;
  virtual HTuple Decode2dBarCode(const HTuple &BarCodeDimension, const HTuple &BarCodeData, HTuple *CorrSymbolData, HTuple *DecodedData, long *DecodingError, HTuple *StructuredAppend) const;
  // Extract the data values of the elements (in ECC 200: ``modules'') inside a
  // bar code region (``Data Matrix symbol'') and their positions in the image.
  virtual HTuple Get2dBarCodePos(const HRegion &BarCodeRegion, const HImage &Image, const HTuple &CodeRegDescr, const HTuple &GenParamNames, const HTuple &GenParamValues, HTuple *BarCodeData, HTuple *DataElementRow, HTuple *DataElementCol) const;
  // Extract the values of the data elements (in ECC 200: ``modules'') inside a
  // bar code region (``Data Matrix symbol'').
  virtual HTuple Get2dBarCode(const HRegion &BarCodeRegion, const HImage &Image, const HTuple &CodeRegDescr, const HTuple &GenParamNames, const HTuple &GenParamValues, HTuple *BarCodeData) const;
  // Find regions that might contain a 2D bar code.
  virtual HRegionArray Find2dBarCode(const HImage &Image, const HTuple &GenParamNames, const HTuple &GenParamValues, HTuple *CodeRegDescr) const;
  // Generate a generic description of a 2D bar code class.
  virtual void Gen2dBarCodeDescr(const HTuple &CodeType, const HTuple &GenParamNames, const HTuple &GenParamValues);
};

#endif
