/*****************************************************************************
 * HFile.h
 ***************************************************************************** 
 *
 * Project:     Halcon/C++
 * Description: Class HFile
 *
 * (c) 1996-2001 by MVTec Software GmbH
 *                  Neherstr. 1, 81675 Muenchen, Germany
 * 
 *****************************************************************************
 *
 * $Revision: 1.4 $
 * $Date: 2003/10/02 09:54:22 $
 *
 */

#ifndef H_FILE_H
#define H_FILE_H

class LIntExport HFile: public HRootObject {
public:
  HFile(void) {id = -1;}
  HFile(const HTuple &FileName, const HTuple &FileType);
  HFile(const char   *FileName, const char   *FileType);

  ~HFile(void);
private:
  // Copying and Assignment not allowed
  HFile(const HFile &inst);
  HFile &operator= (const HFile &inst);
  // Internal Cleanup
  void Cleanup(void);

public: 
  // Tools
  const char *ClassName(void) const {return "HFile";}

  // Cast Operator
  operator HTuple () const {return HTuple(GetHandle());}

  // Access and Manipulation
  long GetHandle(void) const {return id;}
  void SetHandle(long ID) {id = ID;}

private:
  // Handle
  long  id;
public:
  // Open text file.
  virtual void OpenFile(const HTuple &FileName, const HTuple &FileType);
  virtual void OpenFile(const char *FileName, const char *FileType);
  // Write values in a text file.
  virtual void FwriteString(const HTuple &String) const;
  // Read strings from a text file.
  virtual HTuple FreadString(HTuple *IsEOF) const;
  virtual HTuple FreadString(long *IsEOF) const;
  // Read a character from a text file.
  virtual HTuple FreadChar() const;
  // Create a line feed.
  virtual void FnewLine() const;
};

#endif
