/*****************************************************************************
 * HFloatImage.h
 ***************************************************************************** 
 *
 * Project:     Halcon/C++
 * Description: Types for float-images
 *
 * (c) 1996-2000 by MVTec Software GmbH
 *                  Neherstr. 1, 81675 Muenchen, Germany
 * 
 *****************************************************************************
 *
 * $Revision: 1.7 $
 * $Date: 2000/02/24 16:24:10 $
 *
 */

#ifndef H_FLOAT_IMAGE_H
#define H_FLOAT_IMAGE_H



class LIntExport HFloatImage: public HImage {
public:
  HFloatImage(void);
  HFloatImage(const char *file);
  HFloatImage(const HImage &image);
  HFloatImage(const HFloatImage &image);
  HFloatImage(int width, int height);
  HFloatImage(float *ptr, int width, int height);
  virtual ~HFloatImage(void);
  
  // Tools
  const char *ClassName(void) const { return "HFloatImage"; }

  // Pixelzugriff
  double operator[] (long k) const
  { if (!privat) ((HFloatImage*)this)->Private(); return ((float*)ptr)[k]; }
  float &operator[] (long k)
  { if (!init) Init(); return ((float*)ptr)[k]; }
  float &operator()(int x, int y) 
  { if (!init) Init(); return ((float*)ptr)[HLinearCoord(x,y,width)]; }
  float &operator()(long k) 
  { if (!init) Init(); return ((float*)ptr)[k]; }
  void SetPixVal(long k, const HPixVal &val);
    //{ if (!init) Init(); ((float*)ptr)[k] = val; }
  void SetPixVal(int x, int y, const HPixVal &val); 
    //{ if (!init) Init(); ((float*)ptr)[HLinearCoord(x,y,width)] = val; }

  // Klassenoperationen
  static long NumInst(void) { return num_images; }
protected:
private:
  static long num_images;
};


#endif
