/*****************************************************************************
 * HXLDExtParaArray.h
 ***************************************************************************** 
 *
 * Project:     Halcon/libhalcon
 * Description: Class HXLDExtParaArray
 *
 * (c) 1996-2001 by MVTec Software GmbH
 *                  Neherstr. 1, 81675 Muenchen, Germany
 * 
 *****************************************************************************
 *
 * $Revision: 1.13 $
 * $Date: 2001/11/22 13:46:55 $
 *
 */

#ifndef XLD_EXT_PARA_ARRAY_H
#define XLD_EXT_PARA_ARRAY_H


/****************************************************************************/
/*                               HXLDExtParaArray                           */
/****************************************************************************/

class LIntExport HXLDExtParaArray: public HXLDArray {
public:
  HXLDExtParaArray(void) : HXLDArray() {num_xld_ext_para_arrays++;}
  HXLDExtParaArray(Hkey *key, long num);
  HXLDExtParaArray(const Hobject &obj);
  HXLDExtParaArray(const HXLDExtPara &ext_para);
  HXLDExtParaArray(const HXLD &xld);
  HXLDExtParaArray(const HXLDExtParaArray &arr);
  HXLDExtParaArray(const HXLDArray &arr);
  ~HXLDExtParaArray(void) {num_xld_ext_para_arrays--;}

  HXLDExtParaArray &operator= (const HXLDExtParaArray &arr);
  HXLDExtParaArray &operator= (const HXLDArray &arr);

  // Tools
  virtual const char *HClassName(void)    const;
  virtual const char *ClassName(void)     const;
  virtual const char *InstClassName(void) const;
  virtual       INT4  ClassDBID(void)     const {return XLD_EXT_PARALLEL_ID;}
  virtual       Hkey  Key(long i)         const {return array[i].Key();}
  virtual    Hobject  ElemId(long i)      const {return array[i].Id();}

  // Access and Manipulation
  HXLDExtPara  const   &operator[] (long index) const;
  HXLDExtPara          &operator[] (long index);
  HXLDExtParaArray      operator() (long min, long max) const;
  HXLDExtParaArray     &Append(const HXLDExtPara &ext_para);
  HXLDExtParaArray     &Append(const HXLD &xld);
  HXLDExtParaArray     &Append(const HXLDExtParaArray &ext_paras);
  HXLDExtParaArray     &Append(const HXLDArray &xlds);
  virtual void          SetKeys(Hkey *key, long num);
  void                  CopyHXLDExtParaArray(const HXLDExtParaArray &in);
  void                  CopyHXLDArray(const HXLDArray &in);

  // Class Functions
  static long NumInst(void) {return num_xld_ext_para_arrays;}

private:
  static long   num_xld_ext_para_arrays; 
  void          NewLength(long new_num, long old_num);

public:
  // Join modified XLD parallels lying on the same polygon.
  virtual HXLDPolyArray MaxParallelsXld(void) const;
};

#endif
